-------------------------------------------------------------------------------------
------------------------------------Version 0.8.6------------------------------------
-------------------------------------------------------------------------------------
------------------------Created by Kopalov and Henny Smafter-------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
------------------------------------ MOD OPTIONS ------------------------------------
-------------------------------------------------------------------------------------
----------------------------KEYS(See key reference below)----------------------------

local controlkey =  17		-- Control key to use with all other mod keys.
local allowmodkey = 96		-- Key to switch mod ON/OFF.
local mkcustomkey = 97		-- Key to create a custom safehouse.
local mkblipsoff = 103		-- Key to disable all blips.
local mkblipson = 105			-- Key to enable and reload all blips.

-------------------------------------VARIABLES---------------------------------------

local blipsize = 0.7			-- Blip size. Increase or decrease for your taste. Default is 0.7
local spawnhour = 6			-- Clock hour at which you will be spawned in on game load.
local spawnminute = 0			-- Clock minute at which you will be spawned in on game load.
local sleeptimer = 5			-- How many hours does time advance when you save your game.
enablecontroller = true		-- Set to true if you want to use XBox or PS controller.
local waittime = 2750			-- Camera fade-out duration on teleport. Increase if you see textures loading in.

-------------------------------------------------------------------------------------
----------------------------------- KEY REFERENCE -----------------------------------
-------------------------------------------------------------------------------------

--	Space = 32            D4 = 52       O = 79             NumPad4 = 100         F9 = 120
--  PageUp = 33           D5 = 53       P = 80             NumPad5 = 101         F10 = 121
--	Next = 34             D6 = 54       Q = 81             NumPad6 = 102         F11 = 122
--  End = 35              D7 = 55       R = 82             NumPad7 = 103         F12 = 123
--	Home = 36             D8 = 56       S = 83             NumPad8 = 104         F13 = 124
--  Left = 37             D9 = 57       T = 84             NumPad9 = 105         F14 = 125
--	Up = 38               A = 65        U = 85             Multiply = 106        F15 = 126
--  Right = 39            B = 66        V = 86             Add = 107             F16 = 127
--	Down = 40             C = 67        W = 87             Separator = 108       F17 = 128
--  Select = 41           D = 68        X = 88             Subtract = 109        F18 = 129
--  print = 42            E = 69        Y = 89             Decimal = 110         F19 = 130
--	Execute = 43          F = 70        Z = 90             Divide = 111          F20 = 131
--  printScreen = 44      G = 71        LWin = 91          F1 = 112              F21 = 132
--	Insert = 45           H = 72        RWin = 92          F2 = 113              F22 = 133
--  Delete = 46           I = 73        Apps = 93          F3 = 114              F23 = 134
--	Help = 47             J = 74        Sleep = 95         F4 = 115              F24 = 135
--  D0 = 48               K = 75        NumPad0 = 96       F5 = 116				 Ctrl = 17
--	D1 = 49               L = 76        NumPad1 = 97       F6 = 117				 Backspace = 8
--  D2 = 50               M = 77        NumPad2 = 98       F7 = 118              Shift = 16
--	D3 = 51               N = 78        NumPad3 = 99       F8 = 119

-------------------------------------------------------------------------------------
----------------------------- CONTROLLER KEY REFERENCE ------------------------------
-------------------------------------------------------------------------------------

-- Use in code 'CONTROLS.IS_CONTROL_PRESSED(2,X)' without ''.
-- Replace X with one of the numbers below, most have multiple numbers you can try.
-- Thanks goes out to H1Vltg3 who came up with these codes.

-- A    - 73 - 70 - 21 - 18
-- X    - 99 - 22
-- Y    - 75 - 56 - 53 - 49 - 23
-- B    - 80 - 45
--
-- L3   - 86 - 28
-- R3   - 79 - 93 - 50 - 29 - 26

-- LB   - 68 - 89 - 38 - 37
-- RB   - 69 - 76 - 90 - 55 - 44
-- LT   - 77 - 72 - 88 - 91 - 25 - 15 - 10
-- RT   - 78 - 71 - 87 - 92 - 46 - 24 - 14 - 11

-- DPUP - 42 - 27
-- DPDN - 48 - 43 - 20 - 19
-- DPLT - 85 - 58 - 52 - 47
-- DPRT - 74 - 54 - 51

-- RSRT - 66 - 13 - 6
-- RSLT - 5
-- RSUP - 3
-- RSDN - 67 - 12 - 4 - 2

-- LSRT - 64 - 59 - 35 - 30 - 9 - 1
-- LSLT - 63 - 34
-- LSUP - 61 - 40 - 32
-- LSDN - 60 - 41 - 39 - 33 - 31 - 8
--
-- CTRL - 62 - 36

-------------------------------------------------------------------------------------
-------------------------------- KNOWN ISSUES ---------------------------------------
-------------------------------------------------------------------------------------
--Game crash on loading a new game. To fix, disable mod before loading and enable afterwards.

-------------------------------------------------------------------------------------
-------------------------------- CHANGELOG ------------------------------------------
-------------------------------------------------------------------------------------
---------------------------------- 0.8.6 --------------------------------------------
--Save folder is now included in the download, so no need to edit mod file and create a new folder.
--Added option to sell custom savehouse. Just go to the doorstep and follow menu instructions.
--"Turn mod off" option is added. Press Ctrl+Num0 to switch On/Off. Keys are rebindable.
--Only one realtor office is left, as others do not match with the office interior and sometimes are buggy.
--Camera fade-out period on spawn lengthened to ensure full texture load. Fade-out duration can be changed in mod options.
--Realtor camera turn angles tweaked, now camera is always (almost) centered on the right house.
--Switch for controller added to mod options (enablecontroller).
--Tweaked camera height and turn angle for interior view when choosing a house.
--Changed top button label in hotel or apartment rent dialog to prevent misunderstanding. 
--Added update mechanics for local save files. After this and future updates, you will not have to delete them.
--Added warning message for incomplete installation. If you see it, the mod can't access chosen directory.
--Added "Control" button to prevent conflicts with other mods that use Num keys. Now you have to press Ctrl+Num1 etc (rebindable).
--Fixed "Sell house" crash at realtor's office.
--Fixed bug with weekday not changing when player stayed in hotel for a night.
--Fixed issue with button selection staying below active buttons and thus invisible.
--Fixed bug with custom savespot creation key press while driving. To create a custom savehouse now you need to be on foot!
--Fixed bug with mouse movement switching between menu items.
--Fixed on-screen text alignment. Now it is always centered.
---------------------------------- 0.8.5 --------------------------------------------
--Tested camerawork for retailers.
--Added camerawork for houses.
--Added camerawork for hotels.
--Testing if controller keys can work together with keyboard.
--Added controller keys
--Cleaned up code
--Overall bug fixes
---------------------------------- 0.8.4 --------------------------------------------
--Removed houses to allow more custom savehouse creations.
--Assigned interiors to all remaining houses.
--Retail offices are now fully functioning.
---------------------------------- 0.8.3 --------------------------------------------
--Fine tuned saving and exit mechanics in interiors.
--Added interiors to hotels and apartments.
--Redefined interiors based on the type of house.
--Assigned house coordinates and headings for camerawork.
--Added basic realtor mechanics.
--Started reworking the GUI.
--Defined locations and interiors for Realtor Offices.
--Added new save spots for some interiors.
--Added wardrobe spots for all interiors.
--Added options for custom savehouse creation.
---------------------------------- 0.8.2 --------------------------------------------
--Restructering of code.
--Cleanup of code.
--Added save mechanics for interiors.
---------------------------------- 0.8.0 --------------------------------------------
--Redefined the house list.
--Added interiors to houses.
---------------------------------- 0.7.8 --------------------------------------------
--Added new houses there are now 93 houses with most of them having parking spaces.
--Changed default keys.
---------------------------------- 0.7.7 --------------------------------------------
--Added User Defined Keys for turning on/off the blips. This can potentially fix problems with missing mission blips.
---------------------------------- 0.7.6 --------------------------------------------
--Improved map blips.
---------------------------------- 0.7.5 --------------------------------------------
--Added directory check.
--Improved spawn-in mechanic (now camera is faded out while you spawn).
--Added more hotels and houses.
--Added automatic hotel and house list update functionality.
--Added new blips for apartments available for rent.
--Improved buttons (GUI will be completely reworked soon).
--Added ability to turn mod on/off.
--Added greeting message to hotels and apartments, which says how many days you have left.
---------------------------------- 0.7.1 --------------------------------------------
--Disabled some debugging tools.

-------------------------------------------------------------------------------------
-- DO NOT EDIT ANYTHING BELOW UNLESS YOU ARE 100% SURE YOU KNOW WHAT YOU ARE DOING --
-------------------------------------------------------------------------------------

local savepath = "".."scripts/addins/savehousefolder/"
local allowmod = false

local updatehouses = true 
local updatehotels = true
local enablehouse = true
local enablehotels = true
local enablecustom = true

local hupdated = false
local htupdated = false

local sh = {}
local timer = 0
local buttontimer = 0
local price = 0
local textstay = false
local playercash = 0
local currentmodel = 0
local showtext = false

local htable = {}
local httable = {}
local ctable = {}
local htosave = {}
local initialday = 0
local spawnchecker = false

local charactername = "Dummy"

local stopproxtick = false
local tickcooldown = 0
local dirok = true
local intarray = {}
local insidetimer = 0

    ------------------------------------------------------------------Hotel----------------------------------------------------------------------------------
local interior = {{1,151.4981842041,-1008.05859375,-99.000015258789,336.45590209961, 154.34252929688,-1003.2754516602,-98.999961853027,248.35888671875,50000,155.10707092285,-1007.4459228516,-99.333366394043,335.381214141846},--hotel room
	{2,-1003.2720947266,-478.08227539063,51.026782989502,102.60227966309,-1005.7172851563,-474.99221801758,50.026264190674,0.11998824775219,100000,-1010.6307983398,-478.1389465332,51.02668762207,264.74740600586},--Movie makers cabinet-inactive
	-------------------------------------------------------------------Low---------------------------------------------------------------------------------------------
	{3,-107.83421325684,-8.3598766326904,70.519630432129,97.708541870117, -111.13466644287,-10.718485832214,70.519622802734,14.13726234436,250000,-107.83421325684,-8.3598766326904,69.519630432129,147.708541870117},--basic apartment(janitor)
	{4,266.04748535156,-1003.8999023438,-99.004898071289,354.51895141602, 262.90921020508,-1003.1085205078,-99.008575439453,243.61944580078,320000,265.70941162109,-999.93121337891,-100.00862121582,5.977752685547},--small house
	{5,1274.1540527344,-1719.6486816406,54.771457672119,15.826478004456, 1276.2813720703,-1714.5952148438,55.081481933594,238.12216186523,340000,1275.1337890625,-1715.3297119141,53.771446228027,330.003523826599},--Lester's house
	-------------------------------------------------------------------Mid---------------------------------------------------------------------------------------------
	{6,346.99029541016,-1011.2156982422,-99.196182250977,359.0266418457,349.33096313477,-995.07049560547,-99.196182250977,107.60055541992,450000,345.10482788086,-994.36376953125,-99.196258544922,135.84480285645},--Mid class apartment-inactive
	{7,-1151.0661621094,-1520.5487060547,10.992719993591,14.21820640564, -1149.865,-1512.601,10.633,14.21820640564,550000,-1158.2380371094,-1525.419921875,10.232726669312,93.63565063477},--Floyd's house
	-------------------------------------------------------------------High--------------------------------------------------------------------------------------------
	{8,-778.5,317.0,223.2,192.2679901123, -759.6259765625,319.87289428711,217.05030822754,253.18368530273,1250000,-774.22766113281,319.80389404297,222.25765991211,273.13580322266},--Eclypse tower
	{9,1391.1628417969,1131.9582519531,114.33359527588,290.05145263672, 1396.9998779297,1130.5531005859,114.33359527588,172.71952819824,2500000,1398.8028564453,1151.7904052734,114.33359527588,180.85752868652}--Madrazo villa-inactive
	}


local h = {{1,0,0,0,0,0,0,2200.8125,3318.0876464844,46.945693969727,117.28784179688,49500,0,1,2220.2897949219,3303.6506347656,49.994853973389,23.251819610596},
{2,0,0,0,0,0,0,-952.35943603516,-1077.5021972656,2.6772258281708,28.253629684448,295000,0,4,-982.54486083984,-1053.0965576172,11.007244110107,300.31373596191},
{3,0,0,0,0,0,0,1435.3907470703,3657.1955566406,34.405200958252,108.52089691162,75000,0,5,1442.8699951172,3666.7075195313,39.07922744751,74.44860839844},
{4,0,0,0,0,0,0,-1022.5735473633,-896.88433837891,5.4127054214478,211.37385559082,505000,0,4,-1013.7346191406,-927.47308349609,8.2108774185181,3.1813659667969},
{5,0,0,0,0,0,0,2153.0966796875,3360.3532714844,45.402545928955,24.193983078003,25750,0,1,2167.2490234375,3355.4279785156,47.827484130859,35.351470947266},
{6,0,0,0,0,0,0,-1090.4608154297,-926.64636230469,3.1047008037567,212.1895904541,595000,0,7,-1119.1971435547,-926.77618408203,10.367701530457,304.02557373047},
{7,0,0,0,0,0,0,-1037.1337890625,-1605.3999023438,4.9747915267944,222.46809387207,720000,0,4,-1011.959777832,-1617.4758300781,11.673084259033,29.117679595947},
{8,0,0,0,0,0,0,-1117.0482177734,-1505.7077636719,4.3962988853455,28.927146911621,645000,0,7,-1142.2587890625,-1493.4793701172,10.375087738037,300.02947998047},
{9,0,0,0,0,0,0,-1337.673828125,-1161.4385986328,4.5055766105652,110.89149475098,600000,0,4,-1356.8470458984,-1156.3032226563,10.910389900208,298.54351806641},
{10,0,0,0,0,0,0,1830.8414306641,3737.7463378906,33.961898803711,107.97627258301,125000,0,5,1842.8413085938,3732.7761230469,35.550430297852,39.700386047363},
{11,0,0,0,0,0,0,39.481651306152,-1911.35546875,21.953477859497,83.902862548828,195000,0,5,51.058280944824,-1910.3022460938,24.931642532349,53.96491241455},
{12,0,0,0,0,0,0,333.08139038086,-1741.0046386719,29.73052406311,318.06845092773,215000,0,3,334.98596191406,-1755.3868408203,32.872886657715,6.561699867249},
{13,0,0,0,0,0,0,-437.87545776367,6272.158203125,30.068267822266,145.21424865723,399500,0,4,-469.21697998047,6255.6791992188,33.211269378662,332.70550537109},
{14,0,0,0,0,0,0,401.65399169922,-1849.4552001953,27.31974029541,314.00439453125,295000,0,4,414.39733886719,-1869.1846923828,29.957944869995,9.301488876343},
{15,0,0,0,0,0,0,114.29601287842,-1961.1645507813,21.333984375,196.33277893066,180000,0,5,107.65300750732,-1953.1519775391,23.888135910034,287.44509887695},
{16,0,0,0,0,0,0,1289.4512939453,-1710.42578125,55.476684570313,19.81521987915,390000,0,3,1286.1423339844,-1723.3315429688,59.397666931152,349.79141235352},
{17,0,0,0,0,0,0,31.259983062744,6596.8798828125,32.822235107422,41.795986175537,292500,0,3,43.646369934082,6596.3159179688,34.665603637695,43.648971557617},
{18,0,0,0,0,0,0,1379.2691650391,-1515.1256103516,58.435722351074,26.225738525391,435000,0,4,1380.80078125,-1523.7764892578,60.564113616943,354.79281616211},
{19,0,0,0,0,0,0,1336.9313964844,-1578.7204589844,54.444217681885,36.62419128418,365000,0,3,1341.0511474609,-1590.1513671875,57.566982269287,356.97760009766},
{20,0,0,0,0,0,0,1286.6455078125,-1604.4993896484,54.824893951416,197.29341125488,217500,0,5,1229.1462402344,-1625.2846679688,54.932312011719,308.35455322266},
{21,0,0,0,0,0,0,1303.2377929688,-527.39733886719,71.460662841797,342.12057495117,835000,0,7,1312.2270507813,-542.69128417969,74.88809967041,6.8967566490173},
{22,0,0,0,0,0,0,1250.9047851563,-515.43054199219,69.349052429199,79.019554138184,520000,0,4,1258.6536865234,-523.45141601563,71.096855163574,17.956577301025},
{23,0,0,0,0,0,0,1265.7054443359,-457.94311523438,70.517112731934,105.58794403076,560000,0,4,1274.6768798828,-447.19140625,72.396186828613,64.85556030273},
{24,0,0,0,0,0,0,1046.1593017578,-498.12170410156,64.280700683594,168.53160095215,715000,0,7,1059.2034912109,-487.37780761719,68.40486907959,212.34072113037},
{25,0,0,0,0,0,0,1056.1395263672,-448.89996337891,66.25749206543,167.23979187012,745000,0,4,1066.0256347656,-464.51315307617,69.774253845215,9.816276550293},
{26,0,0,0,0,0,0,987.54217529297,-432.95361328125,64.048942565918,44.81941986084,645000,0,3,1005.3862304688,-438.20111083984,66.757835388184,30.442924499512},
{27,0,0,0,0,0,0,-407.22625732422,6314.2197265625,28.941368103027,34.67387008667,180000,0,5,-411.52947998047,6344.80078125,32.059349060059,99.69355773926},
{28,0,0,0,0,0,0,1250.7086181641,-621.0498046875,69.572059631348,23.362808227539,650000,0,3,1268.3135986328,-623.73187255859,72.440963745117,30.684715270996},
{29,0,0,0,0,0,0,928.87811279297,-639.72320556641,58.242473602295,143.78103637695,595000,0,4,938.92504882813,-637.19458007813,61.875179290771,48.16928863525},
{30,0,0,0,0,0,0,-105.6686706543,6528.6103515625,30.166921615601,132.45999145508,320000,0,3,-108.82811737061,6542.4047851563,33.009498596191,254.58534240723},
{31,0,0,0,0,0,0,1323.3922119141,-582.90966796875,73.246360778809,157.66499328613,835000,0,7,1337.30859375,-578.50402832031,77.116676330566,58.96182250977},
{32,0,0,0,0,0,0,-902.19519042969,191.52545166016,69.445999145508,282.95678710938,2150000,0,8,-922.11279296875,166.70768737793,77.602066040039,339.69607543945},
{33,0,0,0,0,0,0,-1536.7906494141,130.46942138672,57.371311187744,317.7099609375,8750000,0,7,-1581.5893554688,107.33052062988,69.459327697754,335.9052734375},
{34,0,0,0,0,0,0,-1570.4189453125,22.349193572998,59.553970336914,166.57012939453,2550000,0,8,-1545.9226074219,35.339611053467,70.470069885254,61.34618377686},
{35,0,0,0,0,0,0,-830.36145019531,114.73859405518,56.029754638672,278.4912109375,2800000,0,7,-844.09790039063,87.27579498291,62.84557723999,348.45193481445},
{36,0,0,0,0,0,0,-930.41888427734,19.417263031006,48.527233123779,40.528820037842,3150000,0,8,-911.30297851563,21.754030227661,56.893688201904,52.620849609375},
{37,0,0,0,0,0,0,-599.00384521484,147.72102355957,61.672718048096,0.39206323027611,249500,0,4,-596.01782226563,125.19607543945,76.446083068848,4.3191466331482},
{38,0,0,0,0,0,0,-1961.1409912109,211.72970581055,86.80396270752,108.39630126953,1750000,0,7,-1952.4149169922,230.40991210938,88.695083618164,102.19819641113},
{39,0,0,0,0,0,0,2332.7746582031,2524.2177734375,46.624931335449,111.58954620361,22500,0,1,2338.4650878906,2505.982421875,50.267723083496,24.500936508179},
{40,0,0,0,0,0,0,2354.828125,2541.0717773438,47.719581604004,9.934118270874,27500,0,1,2370.8994140625,2535.2807617188,49.367210388184,23.053974151611},
{41,0,0,0,0,0,0,-947.94464111328,567.81616210938,101.50568389893,163.24044799805,2150000,0,8,-958.55615234375,524.60705566406,102.76731872559,352.61703491211},
{42,0,0,0,0,0,0,-1090.0938720703,548.63439941406,103.63327789307,290.7294921875,2600000,0,4,-1042.19921875,544.30242919922,110.69590759277,17.7724609375},
{43,0,0,0,0,0,0,-476.5334777832,647.46771240234,144.38616943359,205.27212524414,5650000,0,8,-486.56652832031,596.93743896484,155.65869140625,348.2673034668},
{44,0,0,0,0,0,0,-450.91583251953,395.32049560547,104.77823638916,266.94213867188,3500000,0,7,-461.6305847168,352.16348266602,113.45934295654,342.57006835938},
{45,0,0,0,0,0,0,1428.6372070313,6353.4677734375,23.984996795654,272.24426269531,250,0,7,1428.3265380859,6352.6225585938,23.984996795654,336.76306152344},
{46,0,0,0,0,0,0,1725.5705566406,4642.3442382813,43.875499725342,318.39929199219,177500,0,5,1720.1704101563,4626.3037109375,48.293216705322,348.44372558594},
{47,0,0,0,0,0,0,1682.8530273438,4689.79296875,43.066341400146,90.946388244629,145000,0,3,1690.9064941406,4677.2856445313,45.850521087646,25.260593414307},
{48,0,0,0,0,0,0,1406.9267578125,3656.1921386719,34.430500030518,293.51428222656,99950,0,4,1392.4926757813,3673.6584472656,36.405673980713,282.29960632324},
{49,0,0,0,0,0,0,1774.6715087891,3742.9738769531,34.655307769775,286.49743652344,32500,0,1,1762.01171875,3743.365234375,37.35665512085,306.44296264648},
{50,0,0,0,0,0,0,-1996.2935791016,591.45739746094,118.1019744873,65.868087768555,1650000,0,4,-1981.3917236328,566.41638183594,132.85655212402,7.957555770874},
{51,0,0,0,0,0,0,-1135.9958496094,375.89050292969,71.299774169922,160.65594482422,1300000,0,8,-1186.5662841797,354.39883422852,81.616508483887,329.12463378906},
{52,0,0,0,0,0,0,-1192.7956542969,564.13763427734,100.33944702148,3.0153667926788,2150000,0,4,-1195.2664794922,544.51983642578,105.76403808594,362.9387512207},
{53,0,0,0,0,0,0,3688.0642089844,4562.9233398438,25.183048248291,95.412635803223,33750,0,1,3697.4604492188,4554.033203125,28.136932373047,11.130897521973},
{54,0,0,0,0,0,0,414.77157592773,-217.55018615723,59.910449981689,161.59375,1050000,0,8,531.85412597656,-192.36167907715,88.482429504395,42.43137359619},
{55,0,0,0,0,0,0,484.40582275391,212.75379943848,108.30947113037,71.241493225098,425000,0,4,559.58209228516,222.09951782227,117.982421875,58.36524963379},
{56,0,0,0,0,0,0,178.97630310059,44.399505615234,87.821884155273,17.04497718811,220000,0,3,164.09629821777,40.882709503174,91.315734863281,325.35260009766},
{57,0,0,0,0,0,0,97.64567565918,-256.23526000977,47.68920135498,161.24147033691,160000,0,4,90.301750183105,-241.06378173828,60.916416168213,275.65760803223},
{58,0,0,0,0,0,0,-229.40692138672,6445.3403320313,31.197460174561,314.38879394531,435000,0,7,-199.52262878418,6453.9936523438,35.518356323242,55.23824310303},
{59,0,0,0,0,0,0,-302.22720336914,6326.9931640625,32.88744354248,215.98263549805,385000,0,5,-301.83740234375,6340.7607421875,35.811233520508,116.21669006348},
{60,0,0,0,0,0,0,-1667.6459960938,-441.37097167969,40.356460571289,56.169540405273,1500000,0,7,-1660.2197265625,-457.98712158203,46.012474060059,4.75666809082},
{61,0,0,0,0,0,0,-3093.8383789063,349.35998535156,7.5411024093628,56.16675567627,1450000,0,8,-3145.8854980469,341.95294189453,17.699901580811,322.10189819336},
{62,0,0,0,0,0,0,-3089.3564453125,221.16107177734,14.118478775024,139.04470825195,1395000,0,7,-3095.3754882813,174.04428100586,23.489078521729,354.65939331055},
{63,0,0,0,0,0,0,-3017.0378417969,746.70697021484,27.780559539795,294.57244873047,2350000,0,8,-2991.150390625,778.96051025391,41.523384094238,62.98583984375},
{64,0,0,0,0,0,0,-2972.560546875,642.36553955078,25.992124557495,308.79751586914,2390000,0,7,-2991.6174316406,621.40576171875,33.043231964111,354.13397216797},
{65,0,0,0,0,0,0,-3037.2260742188,558.72552490234,7.507682800293,84.631408691406,260000,0,4,-3071.220703125,554.86285400391,9.4456663131714,317.54251098633},
{66,0,0,0,0,0,0,-3251.2573242188,1027.2862548828,11.757696151733,88.824409484863,890000,0,7,-3283.3757324219,1012.1139526367,19.645685195923,345.12976074219},
{67,0,0,0,0,0,0,3807.7375488281,4478.5161132813,6.365355014801,20.254426956177,37250,0,1,3802.3447265625,4460.9677734375,11.028670310974,342.20892333984},
{68,0,0,0,0,0,0,-213.61064147949,6396.1733398438,33.085037231445,214.94200134277,305000,0,3,-225.57752990723,6400.5869140625,35.851123809814,296.76879882813},
{69,0,0,0,0,0,0,3725.3442382813,4525.7026367188,22.470499038696,344.69345092773,22500,0,1,3739.6525878906,4549.931640625,26.744304656982,64.23803710938}}

	
local htdescr = {{1,"Name","r type","shortstay period","longstay period"},
	{2,"Pipeline Inn","room",2,5},
	{3,"Crown Jewels Motel","room",1,3},
	{4,"Vespucci Beach Rent","apartment",7,30},
	{5,"Vespucci Hotel","room",2,5},
	{6,"Venetian Hotel","room",1,3},
	{7,"Vespucci Beach Rent","apartment",7,30},
	{8,"Vespucci Beach Rent","apartment",7,30},
	{9,"The Viceroy Hotels and Resorts","room",2,5},
	{10,"Little Seoul Sunshine Apartments","apartment",7,30},
	{11,"Crastenburg Hotels & Resorts","room",1,3},
	{12,"Opium Nights Hotel","room",2,5},
	{13,"Casa Cristina","apartment",7,30},
	{14,"Motel","room",3,7},
	{15,"Motel","room",2,5},
	{16,"Von Crastenburg Hotel","room",1,3},
	{17,"Apartment","apartment",7,30},
	{18,"Callisto Apartments","apartment",7,30},
	{19,"Vinewood Gardens Hotel","room",2,5},
	{20,"Centry Manor Hotel","room",2,5},
	{21,"Elgin House Hotel","room",2,5},
	{22,"Motel","room",3,7},
	{23,"Alesandro Hotel","room",1,3},
	{24,"Elkridge Hotel","room",2,5},
	{25,"Banner Hotel & Spa","room",2,5},
	{26,"Motel Wisdahl","room",3,5},
	{27,"Templar Hotels","room",1,3},
	{28,"Hedera Apartment Rent","apartment",7,30},
	{29,"Perrera Beach Motel","room",2,5},
	{30,"Crastenburg Hotels & Resorts","room",2,5},
	{31,"Banner Hotel & Spa","room",2,5},
	{32,"Crastenburg Hotel","room",1,3},
	{33,"Rockford Dorset","room",2,5},
	{34,"The Pink Cage Motel","room",2,5},
	{35,"Apartment Rent","apartment",7,30},
	{36,"Apartment Rent","apartment",7,30},
	{37,"Apartment Rent","apartment",7,30},
	{38,"Hotel","room",2,5},
	{39,"Centry Manor Hotel","house",5,10},
	{40,"The Richman Hotel","room",2,5},
	{41,"Marlowe Vineyard","room",1,2},
	{42,"Dream View Motel","room",3,5},
	{43,"The Motor Hotel","room",2,5},
	}

local ht = {{0,0},
	{2, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -2194.308, -388.276, 13.470,16.740756988525, 125, 1,-2196.001953125,-421.03961181641,17.475967407227,9.6356735229492}, --Pipeline Inn - c
	{3, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1308.911, -931.208, 13.359,16.740756988525, 70, 1,-1304.2725830078,-921.53576660156,16.785820007324,160.0531463623}, --Crown Jewels Motel
	{4, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -988.833, -1575.737, 5.231,16.740756988525, 20, 4,-915.42846679688,-1580.7216796875,17.769908905029,72.668663024902}, --4 rent vb
	{5, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1182.967, -1556.823, 5.038,16.740756988525, 60, 4,-1184.5726318359,-1572.12890625,14.176626205444,345.8005065918},
	{6, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1342.782, -1076.393, 6.939,16.740756988525, 240, 1,-1362.3631591797,-1127.0716552734,21.392923355103,350.96008300781}, -- Venetian
	{7, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1014.465, -1514.411, 6.517,16.740756988525, 20, 4,-958.72351074219,-1502.2630615234,12.304236412048,96.140251159668},
	{8, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -969.335, -1431.057, 7.764,16.740756988525, 20, 4,-900.21649169922,-1357.7850341797,19.593948364258,151.31893920898},
	{9, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -822.091, -1223.600, 7.365,16.740756988525, 200, 1,-689.46734619141,-1201.1041259766,37.534427642822,97.944999694824}, --The Viceroy Hotels and resorts
	{10, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -728.485, -880.107, 22.711,16.740756988525, 30, 4,-743.16650390625,-843.03564453125,34.363357543945,212.66691589355}, --lit seoul sunshine apartments
	{11, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -875.019, -2179.978, 9.809,16.740756988525, 170, 1,-997.28668212891,-2156.5856933594,67.879608154297,268.49234008789}, --Crastenburg Hot&resorts (airop 1)
	{12, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -737.743, -2274.540, 13.437,16.740756988525, 150, 1,-860.78961181641,-2351.5788574219,56.248416900635,298.93350219727}, --Opium nights hotel 2
	{13, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -69.260, -1526.779, 34.235,16.740756988525, 12, 4,-113.28723144531,-1517.9987792969,41.444793701172,261.82897949219}, --casa cristina (near frank 4)
	{14, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 372.191, -1791.460, 29.095,16.740756988525, 70, 1,355.08563232422,-1799.9127197266,32.397724151611,260.630859375}, --motel 4 (near groove)
	{15, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 561.689, -1774.355, 33.443,16.740756988525, 85, 1,589.37078857422,-1753.7926025391,34.5348777771,102.40978240967}, --motel 3
	{16, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 435.71450805664,215.06147766113,103.16605377197,337.65612792969, 220, 1,336.17276000977,132.87686157227,159.00914001465,302.2887878418}, --Von Crastenburg 39
	{17, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 106.98572540283,54.696445465088,77.769584655762,247.14981079102, 35, 4,69.512367248535,31.125217437744,83.412300109863,295.00482177734},--47 apt vw bld
	{18, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 391.36395263672,3.2578566074371,91.93132019043,63.671298980713, 50, 4,354.37658691406,74.447540283203,135.36656188965,213.33442687988},--49 apt Callisto Apartments
	{19, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 328.91983032227,-68.89729309082,73.037803649902,168.40313720703, 200, 1,229.80067443848,-127.62762451172,138.53036499023,306.85464477539},--58 hot Vinewood Gardens
	{20, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 17.840244293213,318.94683837891,110.91898345947,91.281471252441, 120, 1,-4.4611105918884,369.22543334961,127.11449432373,194.71318054199,-123.45003509521,161.33447265625,116.46212768555,261.66851806641},--65 hot Centry Manor
	{21, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -72.256217956543,142.14944458008,81.495307922363,77.494720458984, 180, 1,-123.45003509521,161.33447265625,116.46212768555,261.66851806641},--61 hot Elgin House
	{22, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 66.323944091797,-255.91584777832,52.353881835938,123.30829620361, 85, 1,63.001670837402,-229.06024169922,53.588199615479,199.99621582031},--73 Motel 3
	{23, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 307.70330810547,-727.93682861328,29.316793441772,241.75, 100, 1,357.3076171875,-667.71496582031,70.734985351563,124.97924804688},--86 hot Alesandro Hotel 3
	{24, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 286.54522705078,-937.22918701172,29.467842102051,144.39189147949, 140, 1,246.4772644043,-956.82666015625,29.302433013916,296.2008972168},--93 Elkridge Hotel 2 c94
	{25, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -273.943359375,-883.806640625,31.241750717163,214.62785339355, 150, 1,-232.29626464844,-1052.3269042969,27.266744613647,99.174385070801},--106 Banner Hotel & Spa 2 c107
	{26, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 57.467880249023,-1004.7907104492,29.357431411743,359.03179931641, 100, 1,41.411602020264,-969.98541259766,29.407648086548,205.88945007324},--110 Motel Wisdahl 2 c111
	{27, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 288.04669189453,-1094.8298339844,29.419662475586,91.308853149414, 140, 1,323.7985534668,-1047.5621337891,29.263759613037,134.97959899902},--114 Templar Hotels 2 c115
	{28, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1356.611328125,-791.16937255859,20.242179870605,310.51248168945, 40, 4,-1377.1624755859,-847.82238769531,29.43395614624,335.50442504883},--143 app rent Hedera c144
	{29, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1454.5185546875,-656.00653076172,33.381237030029,45.131774902344, 90, 1,-1505.3262939453,-704.96038818359,27.379346847534,336.83966064453},--147 Perrera Beach Motel c148
	{30, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1545.7017822266,-530.62066650391,36.148220062256,33.43384552002, 250, 1,-1594.7696533203,-512.64611816406,35.388687133789,252.15191650391},--151 Crastenburg Hot&Res c152
	{31, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1660.6646728516,-533.94842529297,36.023990631104,138.85432434082, 140, 1,-1626.3287353516,-615.32916259766,32.421375274658,15.869771003723},--160 banner hotel & spa 3 c161
	{32, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1857.1146240234,-348.12091064453,49.837738037109,148.86190795898, 280, 1,-1873.3569335938,-439.27850341797,46.367931365967,348.59582519531},--166 Crastenburg Hot 1 c167
	{33, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -570.39379882813,-395.46960449219,35.037891387939,357.26895141602, 200, 1,-590.08898925781,-377.14315795898,34.846225738525,229.64892578125},--185 h? Rockford Dorset c186
	{34, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 340.90374755859,-214.79853820801,58.019241333008,103.72160339355, 100, 1,275.61227416992,-240.42242431641,54.048809051514,285.8727722168},--79 Motel 3 The Pink Cage c80
	{35, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -904.55102539063,588.05395507813,101.19079589844,124.93965911865, 25, 4,-907.19555664063,547.23931884766,103.9298324585,353.30892944336},--179 h 9 vw hills c180
	{36, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -385.11584472656,159.71208190918,73.733001708984,150.53001403809, 20, 4,-414.32000732422,102.24530029297,77.248886108398,357.71038818359},--191 h rent 8 c192
	{37, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -336.16714477539,30.917057037354,47.858982086182,88.831214904785, 40, 4,-399.84027099609,33.926322937012,48.275852203369,263.1630859375},--193 h rent 6 c194
	{38, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -273.9186706543,28.600929260254,54.752494812012,251.64653015137, 120, 4,-245.83570861816,29.881273269653,56.653141021729,90.314331054688},--195 h vvw 3 c 196
	{39, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -34.174911499023,347.9462890625,113.99765777588,167.380859375, 180, 1,-35.78832244873,337.41912841797,113.91797637939,350.55169677734},--197 h 2 Centry Manor c198
	{40, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1273.7852783203,315.96365356445,65.511772155762,149.59870910645, 220, 1,-1245.1553955078,247.02830505371,64.278106689453,59.28657913208},--199 h1 The Richman Hotel c200
	{41, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1886.5815429688,2050.2531738281,140.98083496094,192.25430297852, 100, 4,-1901.1721191406,2015.4498291016,141.05686950684,335.9192199707},--211 hrent2 Marlowe Vineyard c212
	{42, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -107.40759277344,6339.9702148438,35.500743865967,231.78079223633, 80, 1,-78.806663513184,6328.1875,31.490365982056,76.804878234863},--213 h3 Dream View Motel c214
	{43, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 1136.5635986328,2641.6394042969,38.143707275391,27.30855178833, 75, 1,1123.3548583984,2675.5356445313,38.383079528809,224.14576721191}--Motor hotel c237
	}

local realtors = {{-943.048,-278.801,39.5951} --Highend Class Dorset Drive 
	--{-468.909,-670.083,-32.417}, --Medium Class 7302 San Andreas Avenue
	--{418.751,-693.695,29.3736}, --Low Class 377-773 Swiss Street
	--{905.94171142578,3586.1865234375,33.54550552368}, --Countryside L,T,TR Grand Senora Street
	--{-41.9243,6472.59,31.5017} --Countryside L,M,H Paleto Blvd.
	}
	
function sh.unload()
	sh.clearblips()
	sh.clearinterblips()
end

function sh.init()
	sh.shGUI = Libs["shGUI"]
	sh.shGUI.hidden = true
	sh.filecheck()
	if dirok then
		if sh.modswitch(3) then
			sh.loadfiles() 
			sh.whoisplayer() 
			initialday = TIME.GET_CLOCK_DAY_OF_MONTH() 
			spawnchecker = true
		end
	end
end


local dialogactive = false
local exittype = 0
local exitdelay = 100
local enterdialog = false
local typetoenter = 0
local insidetick = 0

local isinside = false
local isatrealtor = false
function sh.tick()
	
	local playerdriving = PED.IS_PED_IN_ANY_VEHICLE(PLAYER.PLAYER_PED_ID(), true)
	local playerwanted = PLAYER.GET_PLAYER_WANTED_LEVEL(PLAYER.PLAYER_ID())
	local playerped = PLAYER.GET_PLAYER_PED(PLAYER.PLAYER_PED_ID())
	local currentday = TIME.GET_CLOCK_DAY_OF_MONTH()

	if (timer > 1) then timer = timer - 1 dialogactive = true sh.drawhint() 
	else dialogactive = false end
	
	if (get_key_pressed(allowmodkey) and get_key_pressed(controlkey) and dirok) then
		if allowmod then allowmod=false sh.modswitch(2) sh.showhint(200, "Savehouse mod OFF")
		else allowmod=true sh.modswitch(1) sh.showhint(200, "Savehouse mod ON")
		end end
	
if allowmod then
	
	if (tickcooldown > 0) then stopproxtick = true tickcooldown = tickcooldown - 1
	else stopproxtick = false
	end

	if (not isatrealtor) then sh.checkifinside() end
	
	if isinside and (not dialogactive) and (not isatrealtor) then sh.looksave() end
	
	if (insidetick>0) then insidetick=insidetick-1 end
	
	if isinside and (not dialogactive) and (not isatrealtor) then sh.lookexit() end

	if (not CAM.IS_SCREEN_FADED_OUT()) and spawnchecker then sh.checkspawn() spawnchecker = false end

	if (sh.whoisplayer()~=currentmodel) then currentmodel = sh.whoisplayer() sh.clearblips() sh.addblips() end
	
	if (playerwanted==0) and (not playerdriving) then
		if (get_key_pressed(mkcustomkey) and get_key_pressed(controlkey)) or (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,69)) and (CONTROLS.IS_CONTROL_PRESSED(2,99))) then
			sh.custom() end
		if (not stopproxtick) then sh.getproximityh() sh.getproximityht() sh.getproximityc() sh.getproximityr() end end

	if (currentday > initialday) then
		sh.daypassed() --sh.showhint(125,"Day passed by..."..currentday.." - "..initialday)--Debug tool
		initialday = currentday end
	
	if (get_key_pressed(mkblipsoff) and get_key_pressed(controlkey)) or  (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,77)) and (CONTROLS.IS_CONTROL_PRESSED(2,78)) and (CONTROLS.IS_CONTROL_PRESSED(2,22))) then
		sh.clearblips() end

	if (get_key_pressed(mkblipson) and get_key_pressed(controlkey)) or (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,77)) and (CONTROLS.IS_CONTROL_PRESSED(2,78)) and (CONTROLS.IS_CONTROL_PRESSED(2,70))) then
		sh.clearblips() sh.addblips() end
	
	sh.shGUI.tick()
	
end
end

function sh.modswitch(cmd)
	print("modswitch")
	
	if (cmd==1) then print("option 1")
		local file = io.open(savepath .. "modswitch", "w")
		io.output(file)
		io.write("on" .. "\n")
		io.close(file)
		sh.unload() sh.init()
	elseif (cmd==2) then print("option 2")
		local file = io.open(savepath .. "modswitch", "w")
		io.output(file)
		io.write("off" .. "\n")
		io.close(file)
		sh.unload()
	elseif (cmd==3) then print("option 3")
		local n1 = ""
		for line in io.open(savepath .. "modswitch", "r"):lines() do
			print("msfile line: "..line)
			n1 = line print("N1: "..n1)
		end
		if (n1=="on") then allowmod = true return true --sh.showhint(200, "Mod ON by modswitch") 
		else allowmod = false return false --sh.showhint(200, "Mod OFF by modswitch") 
		end
		io.close(file)
	end
	print("modswitch end")
end

function sh.enterr()
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("Welcome to realtor",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go inside",sh.realtors,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	
end

local gametime = 0
local num = 1
function sh.realtors()
	
	isatrealtor = true
	rcurrenthouse = {}
	rcurrenttable = {}
	num = 1
	
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(260)
	gametime = TIME.GET_CLOCK_HOURS()
	TIME.SET_CLOCK_TIME(12,0,0)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),117.97893078613,-619.11561474609,205.24681396484,true,true,true,true)
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),99.215171813965)
	CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(99.215171813965)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	wait(waittime+750)
	CAM.DO_SCREEN_FADE_IN(250)
	
	wait(200)
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("Choose category",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Sell my house",sh.rclass,4,0,0.33,0.06,0.06)
	sh.shGUI.addButton("High End",sh.rclass,1,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Middle Class",sh.rclass,2,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Low End",sh.rclass,3,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	chosentype = 0
	
end

local chosentype = 0
local hendtable = {}
local mendtable = {}
local lendtable = {}
local ownedtable = {}
local othertable = {}
local rcurrenthouse = 0
local rcurrenttable = {}
local rcamerawork = false
local roperationtype = 1

function sh.rclass(tp)
	
	num = 1
	hendtable = {}
	mendtable = {}
	lendtable = {}
	ownedtable = {}
	othertable = {}
	rcurrenthouse = {}
	rcurrenttable = {}
	chosentype = tp
	local a = 1
	while (a <= #h) do
		local tbl = htable[a]
		if (tonumber(tbl[12])>=750000) and (tonumber(tbl[13])==0) then
			table.insert(hendtable, tbl)
		elseif (tonumber(tbl[12])>=250000) and (tonumber(tbl[12])<750000) and (tonumber(tbl[13])==0) then
			table.insert(mendtable, tbl)
		elseif (tonumber(tbl[12])<250000) and (tonumber(tbl[13])==0) then
			table.insert(lendtable, tbl)
		elseif (tonumber(tbl[13])~=0) and (tonumber(tbl[13])==currentmodel) then
			table.insert(ownedtable, tbl)
		elseif (tonumber(tbl[13])~=0) and (tonumber(tbl[13])~=currentmodel) then
			table.insert(othertable, tbl)
		end
		a = a + 1
	end
	
	print("he: "..#hendtable.." me: "..#mendtable.." le: "..#lendtable.." ow: "..#ownedtable)
	
	if (tp==1) then 
		if (#hendtable>=1) then
		rcurrenttable = hendtable rcurrenthouse = hendtable[num]
		else sh.showhint(150, "No houses to purchase") end
	elseif (tp==2) then 
		if (#mendtable>=1) then
		rcurrenttable = mendtable rcurrenthouse = mendtable[num]
		else sh.showhint(150, "No houses to purchase") end
	elseif (tp==3) then 
		if (#lendtable>=1) then
		rcurrenttable = lendtable rcurrenthouse = lendtable[num]
		else sh.showhint(150, "No houses to purchase") end
	elseif (tp==4) then 
		if (#ownedtable>=1) then
		rcurrenttable = ownedtable rcurrenthouse = ownedtable[num] print("table set to owned, "..#ownedtable) 
		else sh.showhint(150, "You have no houses to sell") end
	end
	
	roperationtype = tp
	num=1
	if (#rcurrenttable>0) then sh.rcamerawork() 
	else sh.showhint(200, "No houses in chosen category") end
	
end


function sh.rselectionmove(cmd)
	
	if (cmd==1) and (num>1) then num = num-1
	elseif (cmd==1) and (num<=1) then sh.showhint(100,"First house in list reached") num=1
	elseif (cmd==2) and (num<#rcurrenttable) then num = num+1
	elseif (cmd==2) and (num>=#rcurrenttable) then sh.showhint(100,"Last house in list reached") num=#rcurrenttable
	end
	rcurrenthouse = rcurrenttable[num]
	sh.rcamerawork()
	
end


function sh.rcamerawork()
	
	if (num>#rcurrenttable) then num=1 end
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(280)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(rcurrenthouse[15]),tonumber(rcurrenthouse[16]),tonumber(rcurrenthouse[17]),true,true,true,true)
	print(tonumber(rcurrenthouse[18]))
	CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(rcurrenthouse[18]))
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(rcurrenthouse[18]))
	--sh.showhint(600,""..rcurrenthouse[1]..", int: "..rcurrenthouse[14]..", head: "..rcurrenthouse[18]) -- For debug
	CAM.SET_GAMEPLAY_CAM_RELATIVE_PITCH(0, -30)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),0)
	TIME.SET_CLOCK_TIME(15, 0, 0)
	GAMEPLAY.SET_WEATHER_TYPE_NOW_PERSIST("CLEAR")
	sh.rupdatenavmenu()
	wait(waittime)
	CAM.DO_SCREEN_FADE_IN(250)
	
end

function sh.rupdatenavmenu()
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("House "..num.." of "..#rcurrenttable.." USD "..tonumber(rcurrenthouse[12]).."",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Next House",sh.rselectionmove,2,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Choose this house",sh.rgoinside,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Previous House",sh.rselectionmove,1,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go back",sh.realtors,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	
end

function sh.rgoinside()
	
	rcurrenthouse = rcurrenttable[num]
	local tp = tonumber(rcurrenthouse[14])
	print("inter in h local:"..tonumber(rcurrenthouse[14]))
	local int = interior[tp]
	print ("set to int "..tonumber(int[1]))
	
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(int[11]),tonumber(int[12]),tonumber(int[13]),true,true,true,true)
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(int[14]))
	CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(int[14])+90)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),0)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	if (roperationtype<4) then
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0 
	sh.shGUI.addButton("USD "..rcurrenthouse[12].."",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Purchase",sh.rbuyconfirm,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go back",sh.rcamerawork,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	elseif (roperationtype==4) then
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("USD "..rcurrenthouse[12].."",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Sell",sh.sellconfirm,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go back",sh.rcamerawork,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	end
	
end

function sh.sellconfirm()

	htosave = rcurrenthouse
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.updateSelection()
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("USD "..htosave[12].."",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Are you sure",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.housesold,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	
end

function sh.housesold()

	print("selling house")
	
	local price = tonumber(htosave[12])
	local mod = (sh.whoisplayer() - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash + price), true)
	print("Sold for "..price)
	local counter = (sh.whoisplayer() + 1)
	table.remove(htosave, counter)
	table.insert(htosave, counter, "0")
	table.remove(htosave, 13)
	table.insert(htosave, 13, "0")
	table.remove(htable, htosave[1])
	table.insert(htable, htosave[1], htosave)
	sh.writetofile()
	sh.showhint(150,"Property sold for $"..price)
	sh.clearblips()
	sh.addblips()
	
	sh.realtors()

	print("house sold")

end

function sh.rbuyconfirm()
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	if (not sh.domoneycheck(tonumber(rcurrenthouse[12]))) then
		sh.shGUI.addButton("Price is USD "..rcurrenthouse[12].."",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Not enough money",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.realtors,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(rcurrenthouse[12]))) then
		sh.shGUI.addButton("Buy for USD "..rcurrenthouse[12].."",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.housebought,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.rgoinside,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	end
	
end

function sh.housebought()
	print("buying house")
	local price = tonumber(rcurrenthouse[12])
	local mod = (sh.whoisplayer() - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash - price), true)
	print("Purchased for "..price)
	local counter = (sh.whoisplayer() + 1)
	local num = tonumber(rcurrenthouse[1])
	table.remove(rcurrenthouse, counter)
	table.insert(rcurrenthouse, counter, "1")
	table.remove(rcurrenthouse, 13)
	table.insert(rcurrenthouse, 13, currentmodel)
	table.remove(htable, num)
	table.insert(htable, num, rcurrenthouse)
	sh.writetofile()
	sh.showhint(150,"Property bought for $"..price)
	sh.clearblips()
	sh.addblips()
	wait(150)

	rcurrenthouse = {}
	rcurrenttable = {}
	sh.realtors()
	print("house bought")
end

local roffice = {}
function sh.rexit()
	
	chosentype = 0
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = true
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	--ENTITY.SET_RANDOM_WEATHER_TYPE() -- More testing needed
	TIME.SET_CLOCK_TIME(gametime,0,0)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(roffice[1]),tonumber(roffice[2]),tonumber(roffice[3]),true,true,true,true)
	ENTITY.SET_ENTITY_HAS_GRAVITY(PLAYER.PLAYER_PED_ID(),true)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(1)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),15000)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	
	rcurrenthouse = {}
	rcurrenttable = {}
	isatrealtor = false
	tickcooldown = 400
	
end

function sh.exithouse()

	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.hidden = true

	if (typetoenter == 1) then
			CAM.DO_SCREEN_FADE_OUT(250)
			wait(500)
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(htosave[8]), tonumber(htosave[9]), tonumber(htosave[10]),true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(htosave[10]))
			lookforexit = false
			wait(250)
			wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
		elseif (typetoenter == 2) then
			CAM.DO_SCREEN_FADE_OUT(250)
			wait(500)
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(httosave[14]), tonumber(httosave[15]), tonumber(httosave[16]),true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(httosave[17]))
			lookforexit = false
			wait(250)
			wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
		elseif (typetoenter == 3) then
			CAM.DO_SCREEN_FADE_OUT(250)
			wait(500)
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(ctosave[8]), tonumber(ctosave[9]), tonumber(ctosave[10]),true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(ctosave[10]))
			lookforexit = false
			wait(250)
			wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	end

	sh.clearinterblips()
	dialogactive = false
	tickcooldown = 200
	
end

function sh.looksave()

	print("lookforsave")

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, intarray[6], intarray[7], intarray[8], true) < 0.5) and (not dialogactive) then
		dialogactive = true
		sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
		sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false
		sh.shGUI.addButton("Save Game",sh.savegame,typetoenter,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Exit House",sh.exithouse,nil,0,0.33,0.06,0.06)
	else sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
		sh.shGUI.buttonCount = 0 sh.shGUI.hidden = true
		dialogactive = false
	end

	print("lookforsave end")

end

function sh.lookexit()

	print("lookexit")

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, intarray[2], intarray[3], intarray[4], true) < 1) then
		if (insidetick<=0) then sh.exithouse() end
	end

	print("lookexit end")

end

--blip 366 - wardrobe

local interblip = {}
local interbliptable = {}
function sh.addinterblips(array)

	print ("adding inter blips")
	sh.clearinterblips()
	interblip = {}
	interbliptable = {}

	local intblip = {}
		intblip = UI.ADD_BLIP_FOR_COORD(intarray[6],intarray[7],intarray[8])
		UI.SET_BLIP_SPRITE(intblip, 441) -------------------------------------change blip icon
		UI.SET_BLIP_SCALE(intblip, blipsize)
		UI.SET_BLIP_AS_SHORT_RANGE(intblip, true)
		table.insert(interbliptable, (#interbliptable+1), intblip)


	print ("inter blips added: "..#interbliptable)

end

function sh.clearinterblips()

	print("clearing inter blips")
	local i = 1
	while (i <= #interbliptable) do
		UI.REMOVE_BLIP(interbliptable[i])
		print("remove blip "..interbliptable[i])
		i=i+1
	end
	wait(500)
	print("inter blips cleared")

end

local cnt = 0
function sh.getproximityh()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cnt >= #htable) then cnt = 0 end
	cnt = cnt + 1
	local coord = htable[cnt]

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[8], coord[9], coord[10], true) < 2) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 200 print("tick cooldown")
		htosave = htable[cnt] print("table set for htable "..cnt)
		sh.safehouse() print("safehouse initiated")
	end

end

local cntht = 1
function sh.getproximityht()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cntht >= #httable) then cntht = 1 end
	cntht = cntht + 1

	local coord = httable[cntht]

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[14], coord[15], coord[16], true) < 2) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 400 print("tick cooldown")
		httosave = httable[cntht] print("table set for httable "..cntht)
		sh.hotel() print("hotel initiated")
	end

end

local cntc = 0
function sh.getproximityc()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cntc >= #ctable) then cntc = 0 end
	cntc = cntc + 1

	local coord = ctable[cntc]

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[8], coord[9], coord[10], true) < 2)
		and (tonumber(coord[13])==1) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 200 print("tick cooldown")
		ctosave = ctable[cntc] print("table set for ctable "..cntc)
		sh.customsh() print("customsh initiated")
	end

end

local cntr = 0
function sh.getproximityr()
	
	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	
	if(cntr >= #realtors) then cntr = 0 end
	cntr = cntr + 1

	local coord = realtors[cntr]
	
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[1], coord[2], coord[3], true) < 2) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 200 print("tick cooldown")
		roffice = realtors[cntr]
		sh.enterr() print("realtors initiated")
	end
	
end

local cntint = 0
function sh.checkifinside()
	
	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	
	if(cntint >= #interior) then cntint = 0 end
	cntint = cntint + 1

	local coord = interior[cntint]
	
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[6], coord[7], coord[8], true) < 20) then
		isinside = true
	else isinside = false end
	
end


function sh.interior()
	print("interior")
	local array = {}
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.hidden = true

	print("typetoenter: "..typetoenter)
	if (typetoenter==1) then array = interior[tonumber(htosave[14])] 	intarray = array
	elseif (typetoenter==2) then array = interior[tonumber(httosave[19])] intarray = array
	elseif (typetoenter==3) then array = interior[tonumber(ctosave[14])] intarray = array 
	end

	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(array[2]), tonumber(array[3]), tonumber(array[4]),true,true,true,true)
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(array[5]))
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	wait(1200)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false)
	
	insidetick = 300
	sh.showhint(150,"Welcome, "..charactername)
	dialogactive = false
	sh.addinterblips(array)

	print("interior end")
end

function sh.safehouse()

	print("safehouse")

	local counter = (currentmodel + 1)
	local owned = false
	local notowned = false
	local ownedbyother = false

	if (tonumber(htosave[13])==currentmodel) then
		owned = true print("sh set to owned")
		typetoenter = 1
		sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
		sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
		sh.shGUI.addButton("Go inside",sh.interior,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	elseif (tonumber(htosave[13])==0) then
		notowned = true print("sh set to not owned")
	elseif (tonumber(htosave[13])~=0 and tonumber(htosave[13])~=currentmodel) then
		ownedbyother = true
	end
	print("end safehouse")
end

function sh.buyconfirm()
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.updateSelection()
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("Are you sure",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.housebought,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
end

function sh.savegame(tp)

	local count = (currentmodel + 4)
	if enablehouse then
	local i = 1
	while (i <= #htable) do
		local val = htable[i]
		table.remove(val, count)
		table.insert(val, count, "0")
		table.remove(htable, i)
		table.insert(htable, i, val)
		i = i + 1
		print("SG active. Changing htable field "..i)
	end
	end

	if enablehotels then
	local o = 2
	while (o <= #httable) do
		local val = httable[o]
		table.remove(val, count)
		table.insert(val, count, "0")
		table.remove(httable, o)
		table.insert(httable, o, val)
		o = o + 1
		print("SG active. Changing httable field "..o)
	end
	end

	if enablecustom then
	local p = 1
	while (p <= #ctable) do
		local val = ctable[p]
		table.remove(val, count)
		table.insert(val, count, "0")
		table.remove(ctable, p)
		table.insert(ctable, p, val)
		p = p + 1
		print("SG active. Changing ctable field "..p)
	end
	end

	if (tp == 1) then
		local num = tonumber(htosave[1])
		local savearray = htable[num]
		table.remove(htosave, count)
		table.insert(htosave, count, "1")
		table.remove(htable, num)
		table.insert(htable, num, htosave)
	elseif (tp == 2) then
		local num = tonumber(httosave[1])
		local savearray = httable[num]
		table.remove(httosave, count)
		table.insert(httosave, count, "1")
		table.remove(httable, num)
		table.insert(httable, num, httosave)
	elseif (tp == 3) then
		local num = tonumber(ctosave[1])
		local savearray = ctable[num]
		table.remove(ctosave, count)
		table.insert(ctosave, count, "1")
		table.remove(ctable, num)
		table.insert(ctable, num, ctosave)
	end

	sh.writetofile()
	print("This type "..tp.." place is set as spawn location")
	
	GAMEPLAY.SET_SAVE_MENU_ACTIVE(true)
	wait(1000)
	
	if (tp == 1) or (tp==2) then sh.camerawork() end
	
	wait(150)
	sh.showhint(150,"This place was set as your spawning spot")
	dialogactive = false
	wait(1500)

end

local ahtdescr = {}
function sh.hotel()

	print("hotel")

	stopproxtick = true print("tick stopped")
	local counter = (currentmodel + 1)
	local owned = false
	local notowned = false
	local num1 = tonumber(httosave[1])
	ahtdescr = htdescr[num1]
	sh.showhint(350,"Welcome to "..ahtdescr[2])

	if (tonumber(httosave[counter])==1) then
	owned = true print("set to owned")
	elseif (tonumber(httosave[counter])==0) then
	notowned = true print("set to not owned")
	end

	if owned then
			print("owned")
			local daysleft = 0
			if (currentmodel==1) then daysleft = tonumber(httosave[8])
			elseif (currentmodel==2) then daysleft = tonumber(httosave[10])
			elseif (currentmodel==3) then daysleft = tonumber(httosave[12]) end
			typetoenter = 2
			sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
			sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
			sh.shGUI.addButton(""..daysleft.." days left",sh.dummy,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Go inside",sh.interior,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	else
		sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
		sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
		sh.shGUI.addButton(ahtdescr[3].." cost is USD "..httosave[18],sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Rent "..ahtdescr[3].." for "..ahtdescr[4].." days",sh.rentshort,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Rent "..ahtdescr[3].." for "..ahtdescr[5].." days",sh.rentlong,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	end

	print("end hotel")

end

function sh.rentshort()
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	if (not sh.domoneycheck(tonumber(ahtdescr[4])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Not enough money",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(ahtdescr[4])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Are you sure",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.hotelrent,1,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	end
end

function sh.rentlong()
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	if (not sh.domoneycheck(tonumber(ahtdescr[5])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Not enough money",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(ahtdescr[5])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Are you sure",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.hotelrent,2,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	end
end

function sh.hotelrent(tp)

	print("renting room")
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = true
	local durofstay = 0
	if (tp==1) then durofstay = tonumber(ahtdescr[4])
	elseif (tp==2) then durofstay = tonumber(ahtdescr[5]) end
	
	local rcount = 0
	if (currentmodel == 1) then rcount = 8
	elseif (currentmodel == 2) then rcount = 10
	elseif (currentmodel == 3) then rcount = 12 end

	table.remove(httosave, rcount)
	table.insert(httosave, rcount, durofstay)

	local price = (durofstay*tonumber(httosave[18]))
	local mod = (sh.whoisplayer() - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash - price), true)
	print("rented for "..price)

	local num = tonumber(httosave[1])
	local counter = (currentmodel + 1)
	table.remove(httosave, counter)
	table.insert(httosave, counter, "1")
	table.remove(httable, num)
	table.insert(httable, num, httosave)
	sh.writetofile()
	stopproxtick = false
	sh.showhint(150,"Rented for USD "..price)
		sh.clearblips()
		sh.addblips()

	print("room rented")

end

function sh.daypassed()
	print("daypassed")
	local i=2
	while (i <= #httable) do
		local val = httable[i]
		local hot = htdescr[i]
		--local counter = (currentmodel + 1)
		local day1 = tonumber(val[8])-1
		if (tonumber(val[2]) == 1) and (day1 > 0) then
			table.remove(val, 8)
			table.insert(val, 8, day1)
		elseif (tonumber(val[2]) == 1) and (day1 <= 0) then
			sh.showhint(300, "Rent time for Michael at "..hot[2].." has ended".."\n".."We hope you enjoyed your stay")
			table.remove(val, 8)
			table.insert(val, 8, "0")
			table.remove(val, 2)
			table.insert(val, 2, "0")
		end

		local day2 = tonumber(val[10])-1
		if (tonumber(val[3]) == 1) and (day2 > 0) then
			table.remove(val, 10)
			table.insert(val, 10, day2)
		elseif (tonumber(val[3]) == 1) and (day2 <= 0) then
			sh.showhint(300, "Rent time for Franklin at "..hot[2].." has ended".."\n".."We hope you enjoyed your stay")
			table.remove(val, 10)
			table.insert(val, 10, "0")
			table.remove(val, 3)
			table.insert(val, 3, "0")
		end

		local day3 = tonumber(val[12])-1
		if (tonumber(val[4]) == 1) and (day3 > 0) then
			table.remove(val, 12)
			table.insert(val, 12, day3)
		elseif (tonumber(val[4]) == 1) and (day3 <= 0) then
			sh.showhint(300, "Rent time for Trevor at "..hot[2].." has ended".."\n".."We hope you enjoyed your stay")
			table.remove(val, 12)
			table.insert(val, 12, "0")
			table.remove(val, 4)
			table.insert(val, 4, "0")
		end
		table.remove(httable, i)
		table.insert(httable, i, val)
		sh.writetofile()
		i = i + 1
	end
		sh.clearblips()
		sh.addblips()
	print("daypassed end")
end

function sh.custom()
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.updateSelection()
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("Create custom house here",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.customchoosetype,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	
	abc=true
	aa=true
	ba=true
	ca=true
	cba=true
	
end

local abc = true
function sh.customchoosetype()

	abc = true
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.updateSelection()
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	if abc then
		sh.shGUI.addButton("Choose House Class",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("High End",sh.custominterior,1,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Middle Class",sh.custominterior,2,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Low End",sh.custominterior,3,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		abc = false
	end
	
end

local aa = true
local ba = true
local ca = true
local cba = true
function sh.custominterior(tp)
	
	aa = true
	ba = true
	ca = true
	cba = true
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.updateSelection()
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	
	if cba then
	if (tp==1) and aa then
	sh.shGUI.addButton("Choose House Interior",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Floyds House 550K",sh.customconfirm,7,0,0.33,0.06,0.06)		
		sh.shGUI.addButton("Luxurious Apartment 1250K",sh.customconfirm,8,0,0.33,0.06,0.06)
		--sh.shGUI.addButton("Madrazo Villa 2500K",sh.customconfirm,9,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.customchoosetype,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		aa = false
	elseif (tp==2) and ba then
		sh.shGUI.addButton("Choose House Interior",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Small House 320K",sh.customconfirm,4,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Lesters house 340K",sh.customconfirm,5,0,0.33,0.06,0.06)
		--sh.shGUI.addButton("Mid Class Apartment 450K",sh.customconfirm,6,0,0.33,0.06,0.06)		
		sh.shGUI.addButton("Go back",sh.customchoosetype,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		ba = false
	elseif (tp==3) and ca then
		sh.shGUI.addButton("Choose House Interior",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Hotel room USD 50K",sh.customconfirm,1,0,0.33,0.06,0.06)
		--sh.shGUI.addButton("Movie makers office 100K",sh.customconfirm,2,0,0.33,0.06,0.06)		
		sh.shGUI.addButton("Basic Apartment 250K",sh.customconfirm,3,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.customchoosetype,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		ca = false
	end
	cba = false
	end
end

local aaa = true
local hprice = 0
local curcusprice = 0
function sh.customconfirm(tp)
	
	aaa = true
	local choosenint = {}
	hprice = 0
	
	for i,itp in ipairs(interior) do
		local b = 1
		while (b<=#interior) do
			local tbl = interior[b]
			if (tp==tonumber(tbl[1])) then choosenint = tbl end
			b = b+1
		end
	end
	
	local cprice = tonumber(choosenint[10])
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.updateSelection()
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	
	if aaa then
		if (not sh.domoneycheck(cprice)) then
		sh.shGUI.addButton("Price is USD "..cprice.."",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Not enough money",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		aaa=false
		elseif (sh.domoneycheck(cprice)) then
		hprice = cprice
		curcusprice = hprice
		sh.shGUI.addButton("Price is USD "..cprice.."",sh.dummy,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Confirm",sh.customcreated,tp,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
		aaa=false
		end
	end
end

function sh.customcreated(tp)

	print("creating custom house")

	local chtocreate = {}
	local coord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	local heading = ENTITY.GET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID())
	local num = #ctable + 1
	local owner = (currentmodel + 1)

	table.insert(chtocreate, 1, num)
	table.insert(chtocreate, 2, "0")
	table.insert(chtocreate, 3, "0")
	table.insert(chtocreate, 4, "0")
	table.insert(chtocreate, 5, "0")
	table.insert(chtocreate, 6, "0")
	table.insert(chtocreate, 7, "0")
	table.insert(chtocreate, 8, coord.x)
	table.insert(chtocreate, 9, coord.y)
	table.insert(chtocreate, 10, coord.z)
	table.insert(chtocreate, 11, heading)
	table.insert(chtocreate, 12, currentmodel)
	table.insert(chtocreate, 13, "1")
	table.insert(chtocreate, 14, tp)
	table.insert(chtocreate, 15, curcusprice)
	table.remove(chtocreate, owner)
	table.insert(chtocreate, owner, "1")
	print("chtocreate table created")

	table.insert(ctable, num, chtocreate)
	sh.writetofile()

	local mod = (currentmodel - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash - hprice), true)

	sh.showhint(150,"Custom safehouse created")
		sh.clearblips()
		sh.addblips()

	stopproxtick = false

	print("house created")

end

function sh.customsh()

	print("custom safehouse")

	stopproxtick = true
	print("tick stopped")
	local counter = (currentmodel + 1)
	print(counter)
	local owned = false
	local notowned = false
	curcusprice = tonumber(ctosave[15])

	if (tonumber(ctosave[counter])==1) then
	owned = true print("set to owned")
	elseif (tonumber(ctosave[counter])==0) then
	notowned = true print("set to not owned")
	end

	if owned then
		print("owned")
		typetoenter = 3

			sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
			sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
			sh.shGUI.addButton("Go Inside",sh.interior,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Sell for USD "..curcusprice,sh.cremoveconf,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	end

	print("end custom safehouse")
end

function sh.cremoveconf()
	
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("Are you sure",sh.dummy,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.cremove,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.cancel,nil,0,0.33,0.06,0.06)
	
end

function sh.cremove()

	print("remove csh")
	local num = tonumber(ctosave[1])
	
	table.remove(ctosave, 13)
	table.insert(ctosave, 13, "0")
	table.remove(ctable, num)
	table.insert(ctable, num, ctosave)
	sh.writetofile()
		sh.clearblips()
		sh.addblips()
	print("csh removed")
	
	local mod = (currentmodel - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash + curcusprice), true)
	sh.showhint(200,"Custom Savehouse sold for $"..curcusprice)
	
	sh.cancel()

end

function sh.writetofile()
	print("writetofile")

	if enablehouse then
	local file = io.open(savepath .. "savehouses", "w")
	io.output(file)
	for a, v in ipairs(htable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
		print("Writing to file savehouses line "..a)

	end
	io.close(file)
	end

	if enablehotels then
		local sfile = io.open(savepath .. "hotels", "w")
		io.output(sfile)
		for a, v in ipairs(httable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
		print("Writing to file hotels line "..a)

	end
	io.close(sfile)
	end

	if enablecustom then
		local nfile = io.open(savepath .. "custom", "w")
		io.output(nfile)
		for a, v in ipairs(ctable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
		print("Writing to file custom line "..a)

	end
	io.close(nfile)
	end

	sh.loadfiles()
	print("writetofile done")
end

function sh.domoneycheck(sum)

		local summa = tonumber(sum)
		local mod = (sh.whoisplayer() - 1)
		local statname = "SP"..mod.."_TOTAL_CASH"
		local hash = GAMEPLAY.GET_HASH_KEY(statname)
		local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
		print("Player Money: "..cash..", sum needed: "..summa)
		if (cash >= summa) then return true else return false end
		print("Money check finished, returning")
end

function sh.filecheck()

	if sh.checkdir() then print("checkdir is not nil")
		local f1 = io.open(savepath .. "savehouses", "r")
		if f1==nil then sh.filemakehouse() else io.close(f1) end
		local f2 = io.open(savepath .. "hotels", "r")
		if f2==nil then sh.filemakehotel() else io.close(f2) end
		local f3 = io.open(savepath .. "custom", "r")
		if f3==nil then sh.filemakecustom() else io.close(f3) end
		local f4 = io.open(savepath .. "modswitch", "r")
		if f4==nil then print("no modstatus file, making one")
			local file = io.open(savepath .. "modswitch", "w")
			if file==nil then return false
			else io.output(file) io.write("on" .. "\n") io.close(file) return true end
		else io.close(f4) end
	else
		allowmod = false
		dirok = false
		sh.showhint(1000,".../scripts/addins/savehousefolder cannot be accessed.".."\n".."Make sure you have that folder and restart.".."\n".."Safehouse Mod OFF")
	end
end

function sh.checkdir()
print("checkdir")
	local file = io.open(savepath .. "dircheck", "w")
	if file==nil then return false
	else io.output(file) io.write("on" .. "\n") io.close(file) return true end
print("checkdir end")
end

function sh.timelapse()
	
	local lhour = TIME.GET_CLOCK_HOURS()
	local currentday = TIME.GET_CLOCK_DAY_OF_MONTH()
	local lminute = TIME.GET_CLOCK_MINUTES()
	local lsec = 0
	local dur = (sleeptimer*60)
	
	local timetick = 1
	while (timetick<dur) do
		if (lhour>=24) then lhour=1 
			TIME.SET_CLOCK_DATE(currentday+1,TIME.GET_CLOCK_MONTH(),TIME.GET_CLOCK_YEAR())
		end
		if (lminute>=60) then lhour=lhour+1 lminute=1 end
		lminute = lminute+1
		timetick = timetick+1
		TIME.SET_CLOCK_TIME(lhour, lminute, lsec)
		sh.showhint(10,""..lhour..":"..lminute)
		wait(10)
	end
	
end

function sh.camerawork()
	
	local coords = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), nil)
	local vals = {coords.x, coords.y, coords.z}
	
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	
	if (typetoenter==1) then 
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(htosave[15]),tonumber(htosave[16]),tonumber(htosave[17]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(htosave[18]))
		CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(htosave[18]))
	elseif (typetoenter==2) then 
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(httosave[20]),tonumber(httosave[21]),tonumber(httosave[22]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(httosave[23]))
		CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(httosave[23]))
	end

	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),0)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	sh.timelapse()
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(vals[1]),tonumber(vals[2]),tonumber(vals[3]),true,true,true,true)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(1)-------------------------------add remember prev state mech
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),15000)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)

end

function sh.filemakehouse()

	print("making house")
	
	local mkhtable = {}
	local i = 1
	while (i <= #h) do
		table.insert(mkhtable, h[i])
		i = i + 1
	end
	print("mkhtable"..#mkhtable)
	local file = io.open(savepath .. "savehouses", "w")
	io.output(file)
	for a, v in ipairs(mkhtable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
	end
	print("file created - h")
	io.close(file)

end

function sh.updateh()
	print("updating house")
	print("htable: "..#htable)
	local updtable = {}
	local rowtable = {}
	if (#h>0) then
		local counter =  1
		while (counter <= #h) do
			rowtable = {}
			local rowhtable =  htable[counter]
				if (rowhtable==nil) then rowhtable={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0} end
			local hrow = h[counter]
				table.insert(rowtable, hrow[1])
				table.insert(rowtable, rowhtable[2])
				table.insert(rowtable, rowhtable[3])
				table.insert(rowtable, rowhtable[4])
				table.insert(rowtable, rowhtable[5])
				table.insert(rowtable, rowhtable[6])
				table.insert(rowtable, rowhtable[7])
				table.insert(rowtable, hrow[8])
				table.insert(rowtable, hrow[9])
				table.insert(rowtable, hrow[10])
				table.insert(rowtable, hrow[11])
				table.insert(rowtable, hrow[12])
				table.insert(rowtable, rowhtable[13])
				table.insert(rowtable, hrow[14])
				table.insert(rowtable, hrow[15])
				table.insert(rowtable, hrow[16])
				table.insert(rowtable, hrow[17])
				table.insert(rowtable, hrow[18])
			table.remove(htable, counter)
			table.insert(htable, counter, rowtable)
			print("doing while, current line="..counter)
			counter = counter + 1
		end
		print("while done, htable entries: "..#htable)
	end
	hupdated = true
	sh.writetofile()
	print("updating house done")
end

function sh.updateht()
	print("updating hotel")
	print("httable: "..#httable)
	local updtable = {}
	local rowtable = {}
	if (#ht>0) then
		local counter =  1
		while (counter <= #ht) do
			rowtable = {}
			local rowhtable =  httable[counter]
				if (rowhtable==nil) then rowhtable={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0} end
			local hrow = ht[counter]
				table.insert(rowtable, hrow[1])
				table.insert(rowtable, rowhtable[2])
				table.insert(rowtable, rowhtable[3])
				table.insert(rowtable, rowhtable[4])
				table.insert(rowtable, rowhtable[5])
				table.insert(rowtable, rowhtable[6])
				table.insert(rowtable, rowhtable[7])
				table.insert(rowtable, rowhtable[8])
				table.insert(rowtable, rowhtable[9])
				table.insert(rowtable, rowhtable[10])
				table.insert(rowtable, rowhtable[11])
				table.insert(rowtable, rowhtable[12])
				table.insert(rowtable, rowhtable[13])
				table.insert(rowtable, hrow[14])
				table.insert(rowtable, hrow[15])
				table.insert(rowtable, hrow[16])
				table.insert(rowtable, hrow[17])
				table.insert(rowtable, hrow[18])
				table.insert(rowtable, hrow[19])
				table.insert(rowtable, hrow[20])
				table.insert(rowtable, hrow[21])
				table.insert(rowtable, hrow[22])
				table.insert(rowtable, hrow[23])
			table.remove(httable, counter)
			table.insert(httable, counter, rowtable)
			print("doing while, current line="..counter)
			counter = counter + 1
		end
		print("while done, ht_table entries: "..#httable)
	end
	htupdated = true
	sh.writetofile()
	print("updating hotel done")
end

function sh.filemakehotel()

	local mkhottable = {}
	local i = 1
	while (i <= #ht) do
		table.insert(mkhottable, ht[i])
		i = i + 1
	end
	print("mkhottable"..#mkhottable)
	local file = io.open(savepath .. "hotels", "w")
	io.output(file)
	for a, v in ipairs(mkhottable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
	end
	print("file created - hot")
	io.close(file)

end

function sh.filemakecustom()

	local c = {{1, 1,0,0, 0,0,0,-1066.7385253906,-1152.8004150391,2.3458766937256,24.428289413452,1,0},
	}
	local mkctable = {}
	local i = 1
	while (i <= #c) do
		table.insert(mkctable, c[i])
		i = i + 1
	end
	print("mkctable"..#mkctable)
	local file = io.open(savepath .. "custom", "w")
	io.output(file)
	for a, v in ipairs(mkctable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
	end
	print("file created - cus")
	io.close(file)

end

local dirch = {}
function sh.loadfiles()
	print("loadfiles")
	htable = {}
	httable = {}
	ctable = {}
	dirch = {}

	if enablehouse then
		for line in io.open(savepath .. "savehouses", "r"):lines() do
		sh.getarrayh(line)
		end
	end

	if enablehotels then
		for line in io.open(savepath .. "hotels", "r"):lines() do
		sh.getarrayht(line)
		end
	end

	if enablecustom then
		for line in io.open(savepath .. "custom", "r"):lines() do
		sh.getarrayc(line)
		end
	end
	
	if updatehouses and (not hupdated) then sh.updateh() end
	if updatehotels and (not htupdated) then sh.updateht() end

	print("files loaded")

end

function sh.getarrayh(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(htable, vals)
	print("entries in htable:"..#htable)
end

function sh.getarrayht(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(httable, vals)
	print("entries in httable:"..#httable)
end

function sh.getarrayc(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(ctable, vals)
	print("entries in ctable:"..#ctable)
end

function sh.getarrayd(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(dirch, vals)
	print("entries in dirch:"..#dirch)
end

function sh.val_to_str (v)
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '' .. string.gsub(v,'"', '\\"' ) .. ''
  else
    return "table" == type( v ) and sh.tostring( v ) or
      tostring( v )
  end
end

function sh.key_to_str (k)
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. sh.val_to_str( k ) .. "]"
  end
end

function sh.tostring (tbl)
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, sh.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        sh.key_to_str( k ) .. "=" .. sh.val_to_str( v ) )
    end
  end
  return table.concat( result, "," )
end

function sh.whoisplayer()

	local model = 0
	if (PED.IS_PED_MODEL(PLAYER.PLAYER_PED_ID(), GAMEPLAY.GET_HASH_KEY("player_zero"))) then model = 1 charactername = "Michael"
	elseif (PED.IS_PED_MODEL(PLAYER.PLAYER_PED_ID(), GAMEPLAY.GET_HASH_KEY("player_one"))) then model = 2 charactername = "Franklin"
	elseif (PED.IS_PED_MODEL(PLAYER.PLAYER_PED_ID(), GAMEPLAY.GET_HASH_KEY("player_two"))) then model = 3 charactername = "Trevor"
	end
	return model

end

function sh.checkspawn()

	print("checking spawn")
	local counter = (currentmodel + 4)
	local stopper = false

	if enablehouse then
		local i = 1
		while (i <= #htable) do
			local vdata = htable[i]
			if (tonumber(vdata[counter])==1) then
				stopper = true
				sh.spawnplayer(1, htable[i])
				break
			elseif tonumber(vdata[counter])==0 then
				i = i + 1
			end
		end
	end

	if enablehotels then
		local i = 2
		while (i <= #httable) do
			local vdata = httable[i]
			if (tonumber(vdata[counter])==1) then
				stopper = true
				sh.spawnplayer(2, httable[i])
				break
			elseif tonumber(vdata[counter])==0 then
				i = i + 1
			end
		end
	end


	if enablecustom then
		local i = 1
		while (i <= #ctable) do
			local vdata = ctable[i]
			if (tonumber(vdata[counter])==1) then
				sh.spawnplayer(1, ctable[i])
				break
			elseif tonumber(vdata[counter])==0 then
				i = i + 1
			end
		end
	end

	print("checkspawn finished")

end

function sh.spawnplayer(sptype, array)

	print("spawnplayer")
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	if (sptype == 1) then print("1")
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(array[8]), tonumber(array[9]), tonumber(array[10]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(array[11]))
		TIME.SET_CLOCK_TIME(spawnhour, spawnminute, 0)
	elseif (sptype == 2) then print("2")
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(array[14]), tonumber(array[15]), tonumber(array[16]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(array[17]))
		TIME.SET_CLOCK_TIME(spawnhour, spawnminute, 0)
	end
	tickcooldown = 200
	wait(500)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	print("spawnplayer end")
end

local hinttoshow = "SAFEHOUSE MOD LOADED"

function sh.showhint(tmr, text)
	timer = tmr
	hinttoshow = text
end

-- Added for GUI
function UI.renderBox(xMin,xMax,yMin,yMax,color1,color2,color3,color4)
	GRAPHICS.DRAW_RECT(xMin, yMin,xMax, yMax, color1, color2, color3, color4);
end

-- Changed for GUI
function sh.drawhint()
		UI.SET_TEXT_FONT(4)
		UI.SET_TEXT_SCALE(0.0, 0.6)
		UI.SET_TEXT_COLOUR(255, 255, 255, 255)
		UI.SET_TEXT_WRAP(0 , 2)
		UI.SET_TEXT_CENTRE(true)
		UI.SET_TEXT_DROPSHADOW(255, 255, 255, 255, 100)
		UI.SET_TEXT_EDGE(5, 0, 0, 0, 255)
		UI._SET_TEXT_ENTRY("STRING")
		UI._ADD_TEXT_COMPONENT_STRING(hinttoshow)
		UI._DRAW_TEXT(0.5, 0.3)
		timer = timer-1
end

local bliptable = {}

local blip = {}
local shblip = {}
local phblip = {}
local ohblip = {}
local ahtblip = {}
local ohtblip = {}
local cblip = {}
local forrent = {}
local rented = {}

function sh.addblips()
	print("adding blips")

	bliptable = {}
	shblip = {}
	phblip = {}
	ohblip = {}
	ahtblip = {}
	ohtblip = {}
	cblip = {}
	forrent = {}
	rented = {}
	
	for i, coord in ipairs(realtors) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(tonumber(coord[1]),tonumber(coord[2]),tonumber(coord[3]))
			UI.SET_BLIP_SPRITE(blip[i], 408)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
	end
	
	if enablehouse then
		local a = 1
		while (a <= #htable) do
			local tbl = htable[a]
			if (tonumber(tbl[13])==currentmodel) then
				table.insert(shblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})
			elseif (tonumber(tbl[13])==0) then
				table.insert(phblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})
			elseif (tonumber(tbl[13])~=0) and (tonumber(tbl[13])~=currentmodel) then
				table.insert(ohblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})

			end
			a = a + 1
		end

		for i, coord in ipairs(shblip) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 40)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end

		--for i, coord in ipairs(phblip) do
		--	blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
		--	UI.SET_BLIP_SPRITE(blip[i], 350)
		--	UI.SET_BLIP_SCALE(blip[i], blipsize)
		--	UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
		--	table.insert(bliptable, (#bliptable+1), blip[i])
		--end

		--for i, coord in ipairs(ohblip) do
		--	local j = i + 1
		--	blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
		--	UI.SET_BLIP_SPRITE(blip[i], 350)
		--	UI.SET_BLIP_SCALE(blip[i], blipsize)
		--	UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
		--	blip[j] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
		--	UI.SET_BLIP_SPRITE(blip[j], 163)
		--	UI.SET_BLIP_SCALE(blip[j], (blipsize-0.1))
		--	UI.SET_BLIP_AS_SHORT_RANGE(blip[j], true)
		--	table.insert(bliptable, (#bliptable+1), blip[i])
		--	table.insert(bliptable, (#bliptable+1), blip[j])
		--end
	end

	if  enablehotels then
		local b = 2
		while (b <= #httable) do
			local tbl = httable[b]
			local counter = (currentmodel + 1)
			if (tonumber(tbl[counter])==1) and (tonumber(tbl[19])==1) then
				table.insert(ahtblip, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			elseif (tonumber(tbl[counter])==0) and (tonumber(tbl[19])==1) then
				table.insert(ohtblip, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			end
			b = b + 1
		end

		for i, coord in ipairs(ahtblip) do
			local j = i + 1
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 417)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			blip[j] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[j], 431)
			UI.SET_BLIP_SCALE(blip[j], (blipsize - 0.1))
			UI.SET_BLIP_AS_SHORT_RANGE(blip[j], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
			table.insert(bliptable, (#bliptable+1), blip[j])
		end

		for i, coord in ipairs(ohtblip) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 417)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end

	end

	if enablehotels then
		local d = 2
		while (d <= #httable) do
			local tbl = httable[d]
			local counter = (currentmodel + 1)
			if (tonumber(tbl[counter])==1) and (tonumber(tbl[19])==2) then
				table.insert(rented, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			elseif (tonumber(tbl[counter])==0) and (tonumber(tbl[19])==4) then
				table.insert(forrent, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			end
			d = d + 1
		end

		for i, coord in ipairs(rented) do
			local j = i + 1
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 411)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			blip[j] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[j], 431)
			UI.SET_BLIP_SCALE(blip[j], (blipsize - 0.1))
			UI.SET_BLIP_AS_SHORT_RANGE(blip[j], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
			table.insert(bliptable, (#bliptable+1), blip[j])
		end

		for i, coord in ipairs(forrent) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 411)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end
	end

	if enablecustom then
		local c = 1
		while (c <= #ctable) do
			local tbl = ctable[c]
			if (tonumber(tbl[12])==currentmodel) and (tonumber(tbl[13])==1) then
				table.insert(cblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})
			end
			c = c + 1
		end

		for i, coord in ipairs(cblip) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 40)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end
	end

	print("shblip"..#shblip)
	print("phblip"..#phblip)
	print("ohblip"..#ohblip)
	print("ahtblip"..#ahtblip)
	print("ohtblip"..#ohtblip)
	print("forrent"..#forrent)
	print("rented"..#rented)
	print("cblip"..#cblip)
	print("bliptable "..#bliptable)

end

local realtorbliptable = {}
function sh.clearblips()

	print("clearing blips")
	local i = 1
	while (i <= #bliptable) do
		UI.REMOVE_BLIP(bliptable[i])
		print("remove blip "..bliptable[i])
		i=i+1
	end
	while (i <= #realtorbliptable) do
		UI.REMOVE_BLIP(realtorbliptable[i])
		print("remove blip "..realtorbliptable[i])
		i=i+1
	end
	wait(500)
	print("blips cleared")

end

function sh.cancel()
	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.dummy,nil,0,0.0,0.0,0.0) 
	sh.shGUI.hidden = true
	if isatrealtor then sh.rexit() end
	tickcooldown = 200
	dialogactive = false
end

function sh.dummy()
	sh.shGUI.hidden = false sh.shGUI.selection = 0
end

return sh
